package de.osci.osci12.samples.impl;

import de.osci.osci12.extinterfaces.TransportI;

import org.apache.commons.logging.*;

import java.io.*;
import java.io.InputStream;

import java.net.*;

import java.util.*;


/**
 * Beispiel-Implementierung eines Transport-Interfaces.
 *
 * <p>Copyright  2007 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N. Bngener
 * @version 1.0
 * @see de.osci.osci12.extinterfaces.TransportI
 */
public class HttpTransport implements TransportI
{
  private static Log log = LogFactory.getLog(HttpTransport.class);
  InputStream inStream = null;
  URLConnection con;
  ResourceBundle text = ResourceBundle.getBundle("de.osci.osci12.extinterfaces.language.Text", Locale.getDefault());

  /**
   * Creates a new HttpTransport object.
   */
  public HttpTransport()
  {
  }

  /**
   * Liefert die Versionsnummer
   * @return Versionsnummer
   */
  public String getVendor()
  {
    return "BOS";
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public String getVersion()
  {
    return "0.9";
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public TransportI newInstance()
  {
    return new HttpTransport();
  }

  /**
   * undocumented
   *
   * @return undocumented
   *
   * @throws IOException undocumented
   */
  public InputStream getResponseStream() throws IOException
  {
    return con.getInputStream();
  }

  /**
   * undocumented
   *
   * @param uri undocumented
   *
   * @return undocumented
   *
   * @throws IOException undocumented
   */
  public boolean isOnline(java.net.URI uri) throws IOException
  {
    try
    {
      con = uri.toURL().openConnection();
      con.connect();

      return true;
    }
    catch (MalformedURLException ex)
    {
      throw new IOException(text.getString("invalid_url") + ": " + ex.getLocalizedMessage());
    }
    catch (IOException ex)
    {
      return false;
    }
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public long getContentLength()
  {
    /**@todo Diese de.osci.osci12.extinterfaces.transport.TransportI-Methode implementieren*/
    throw new java.lang.UnsupportedOperationException("Methode getContentLength() noch nicht implementiert.");
  }

  /**
   * undocumented
   *
   * @param uri undocumented
   * @param laenge undocumented
   *
   * @return undocumented
   *
   * @throws IOException undocumented
   */
  public OutputStream getConnection(java.net.URI uri, long laenge)
                             throws IOException
  {
    try
    {
      con = uri.toURL().openConnection();
      con.setDoOutput(true);

      OutputStream s = con.getOutputStream();

      return s;
    }
    catch (MalformedURLException ex)
    {
      throw new IOException(text.getString("invalid_url") + ": " + ex.getLocalizedMessage());
    }
  }
}
