package de.osci.helper;

import java.io.IOException;
import java.io.OutputStream;


/**
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author N. Bngener
 * @version 1.5
 */
public class NullOutputStream extends OutputStream
{
  //  private static Log log = LogFactory.getLog(NullOutputStream.class);
  private long count;

  /**
   * Creates a new NullOutputStream object.
   */
  public NullOutputStream()
  {
  }

  /**
   * undocumented
   *
   * @param b undocumented
   *
   * @throws IOException undocumented
   */
  public void write(int b) throws IOException
  {
    count++;
  }

  /**
   * undocumented
   *
   * @param b undocumented
   * @param off undocumented
   * @param len undocumented
   *
   * @throws IOException undocumented
   */
  public void write(byte[] b, int off, int len) throws IOException
  {
    count += len;
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public long getLength()
  {
    return count;
  }
}
