package de.osci.osci12;

import java.util.ResourceBundle;


/**
 * Diese Klasse stellt die Superklasse aller bibliothekseigenen
 * Exceptions dar.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class OSCIException extends Exception
{
  protected String errorCode = "null";
  public static final ResourceBundle us_text = ResourceBundle.getBundle("de.osci.osci12.extinterfaces.language.Text",
                                                                        java.util.Locale.US);

  //  protected String message;
  public OSCIException()
  {
  }

  /**
   * Erzeugt ein OSCIException-Objekt mit einem erklrenden String und
   * einem Fehlercode. Als Fehlercode kann jeder String verwendet werden, fr den
   * ein entsprechender Eintrag in der zum gesetzten default-Locale gehrenden
   * Sprachdatei (s. Package de.osci.osci12.extinterfaces.language) vorhanden ist.
   * @param errorCode
   */
  public OSCIException(String errorCode)
  {
    super();
    this.errorCode = errorCode;
  }

  /**
   * Creates a new OSCIException object.
   *
   * @param message undocumented
   * @param errorCode undocumented
   */
  protected OSCIException(String message, String errorCode)
  {
    super(message);
    this.errorCode = errorCode;
  }

  /**
   * Liefert den OSCI-Fehlercode.
   * @return Code
   */
  public String getErrorCode()
  {
    return errorCode;
  }

  /**
   * Liefert die Exception-Nachricht in der jeweiligen Sprache (Default-Locale).
   * @return lokale Nachricht
   */
  public String getLocalizedMessage()
  {
    try
    {
      return de.osci.osci12.common.DialogHandler.text.getString(errorCode);
    }
    catch (Exception ex)
    {
      return getMessage();
    }
  }
}
