package de.osci.osci12.common;

import de.osci.osci12.OSCIException;


/**
 * Diese Exception zeigt eine der in der OSCI-Spezifikation
 * definierten Fehlermeldungen auf Nachrichtenebene (faultcode soap:Client) an.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class SoapClientException extends OSCIException
{
  /**
   * Erzeugt ein SoapClientException-Objekt mit einem erklrenden String als
   * Message und einem Fehlercode.
   * @param oscicode
   */
  public SoapClientException(String oscicode, String faultstring)
  {
    super(faultstring, oscicode);
  }

  /**
   * Erzeugt ein SoapClientException-Objekt mit einem Fehlercode und erklrendem
   * String als Message. Als Message-String wird der dem Code entsprechende Eintrag
   * in der zum aktuellen default-Locale gehrenden Sprachdatei (s. Package
   * de.osci.osci12.extinterfaces.language) gesetzt.
   * @param oscicode
   */
  public SoapClientException(String oscicode)
  {
    this(oscicode, DialogHandler.text.getString(oscicode));
  }
}
