package de.osci.osci12.common;

import de.osci.osci12.OSCIException;


/**
 * Diese Exception zeigt eine der in der OSCI-Spezifikation
 * definierten Fehlermeldungen auf Nachrichtenebene (faultcode soap:Server) an.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class SoapServerException extends OSCIException
{
  /**
   * Erzeugt ein SoapServerException-Objekt mit einem erklrenden String und
   * einem Fehlercode. Als Fehlercode kann jeder String verwendet werden, fr den
   * ein entsprechender Eintrag in der zum gesetzten default-Locale gehrenden
   * Sprachdatei (s. Package de.osci.osci12.extinterfaces.language) vorhanden ist.
   * @param oscicode OSCI-Fehlercode
   * @param faultstring Fehlertext
   */
  public SoapServerException(String oscicode, String faultstring)
  {
    super(faultstring, oscicode);
  }
}
