package de.osci.osci12.extinterfaces;

/**
 * Diese Erweiterung der OSCIDataSource-Klasse wurde mit der Version 1.2.3
 * eingefhrt. Das zustzliche Flag "confidential" informiert die Implementierung
 * darber, ob die zu speichernden Daten ggf. durch Zugriffsbeschrnkungen
 * oder Verschlsselung geschtzt werden sollten. Die OSCI-Bibliothek setzt
 * dieses Flag beim Anlegen von Content-Daten direkt nach der Instanziierung auf true.
 * Falls die Implementierung die Daten verschlsselt, kann hierzu der 128-Bit-AES-Key
 * verwendet werden, der im DialogHandler als statische Variable bereitgestellt
 * wird. <b>Hinweis:</b> Unverschlsslte Attachments werden als nicht sicherheitskritisch
 * betrachtet. Es steht der Implmentierung frei, diese ebenfalls zu schtzen.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 * @see de.osci.osci12.common.SwapBuffer
 * @see de.osci.osci12.common.DialogHandler#getTempSymKey()
 */
public abstract class OSCIDataSourceExt123 extends OSCIDataSource
{
  protected boolean confidential = false;

  /**
   * Wird bei ggf. vertraulichen Daten von der Bibliothek mit "true"
   * aufgerufen.
   *
   * @param isConfidential vertrauliche Daten
   */
  public void setConfidential(boolean isConfidential)
  {
    confidential = isConfidential;
  }
}
