package de.osci.osci12.messageparts;

/**
 * <p>Diese Klasse reprsentiert einen Feedback-Eintrag einer OSCIResponseTo-Nachricht</p>
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class FeedbackObject
{
  //  private static Log log = LogFactory.getLog(FeedbackObject.class);
  private String lang;
  private String code;
  private String text;

  FeedbackObject(String[] feedback)
  {
    lang = feedback[0];
    code = feedback[1];
    text = feedback[2];
  }

  /**
   * Liefert das Sprachkrzel des Feedbackeintrags (de, en...).
   * @return das Sprachkrzel
   */
  public String getLanguage()
  {
    return lang;
  }

  /**
   * Liefert den Rckmeldecode des Feedbackeintrags.
   * @return der Rckmeldecode
   */
  public String getCode()
  {
    return code;
  }

  /**
   * Liefert den Text des Feedbackeintrags.
   * @return der Text
   */
  public String getText()
  {
    return text;
  }
}
