package de.osci.osci12.messagetypes;

import de.osci.osci12.OSCIException;
import de.osci.osci12.common.DialogHandler;
import de.osci.osci12.common.OSCIErrorException;
import de.osci.osci12.signature.OSCISignatureException;

import org.xml.sax.XMLReader;

import java.io.IOException;
import java.io.InputStream;


/**
 * Die Klasse ist der Einrittspunkt fr Nachrichten, die bei einem passiven Empfnger
 * eingehen.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
class StoredMessageParser extends de.osci.osci12.messagetypes.IncomingMSGParser
{
  OSCIEnvelopeBuilder getParser(XMLReader reader, DialogHandler dh)
  {
    return new StoredEnvelopeBuilder(reader);
  }

  /**
   * undocumented
   *
   * @param input undocumented
   *
   * @return undocumented
   *
   * @throws IOException undocumented
   * @throws OSCIException undocumented
   * @throws java.security.NoSuchAlgorithmException undocumented
   * @throws OSCIErrorException undocumented
   */
  public StoredMessage parseStream(InputStream input)
                            throws IOException, 
                                   OSCIException, 
                                   java.security.NoSuchAlgorithmException
  {
    try
    {
      return (StoredMessage) super.parseStream(input, null, true, null);
    }
    catch (OSCISignatureException ex)
    {
      throw new OSCIErrorException("9601");
    }
  }
}
