package de.osci.osci12.roles;

import de.osci.osci12.OSCIException;


/**
 * Diese Exception zeigt an, dass ein Rollenobjekt fr eine unzulssige Operation
 * verwendet wurde. Beispiel: An die Methode ContentContainer.sign(Role) wird ein
 * Role-Objekt bergeben, welches kein Signer-Objekt enthlt.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class OSCIRoleException extends OSCIException
{
  /**
   * Creates a new OSCIRoleException object.
   *
   * @param message undocumented
   */
  public OSCIRoleException(String message)
  {
    super(message);
  }

  /**
   * Creates a new OSCISignatureException object.
   *
   * @param errorCode undocumented
   */
  public OSCIRoleException(String errorCode, String addInfo)
  {
    super(addInfo, errorCode);
  }

  /**
   * Liefert die Exception-Nachricht in der jeweiligen Sprache (Default-Locale).
   * @return lokale Nachricht
   */
  public String getLocalizedMessage()
  {
    return super.getLocalizedMessage() + " '" + super.getMessage() + "'";
  }

}
