/*
 *  Generated by Together
 */
package de.osci.osci12.roles;

import de.osci.osci12.extinterfaces.crypto.Decrypter;
import de.osci.osci12.extinterfaces.crypto.Signer;

import java.security.cert.X509Certificate;


/**
 *  Diese Klasse stellt einen OSCI-Absender dar.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class Originator extends Role
{
  /**
   *  Konstruktor fr den Versand einer Nachricht.
   *
   *  @param  signer Signer-Objekt, welches die Signatur der Nachricht erstellen
   *  soll (kann null sein, wenn keine Signatur gewnscht).
   *  @param  decrypter Decrypter-Objekt, welches den Inhalt der Rckantwort entschlsseln
   *  soll.
   */
  public Originator(Signer signer, Decrypter decrypter)
  {
    super(signer, decrypter);
  }

  /**
   *  Konstruktor fr den Empfang einer Nachricht.
   *
   *  @param  signatureCertificate Zertifikat, mit dem die Signatur der Nachricht geprft werden kann
   *  @param  cipherCertificate Zertifikat, mit dem die Rckantwort verschlsselt werden soll
   */
  public Originator(X509Certificate signatureCertificate, X509Certificate cipherCertificate)
  {
    super(signatureCertificate, cipherCertificate);
  }
}
