package de.osci.osci12.roles;

import de.osci.osci12.extinterfaces.crypto.Decrypter;

import java.security.cert.X509Certificate;


/**
 *  Diese Klasse stellt einen OSCI-Leser dar.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class Reader extends Role
{
  //  private static Log log = LogFactory.getLog(Reader.class);
  private static int idNr = -1;

  /**
   *  Konstruktor fr den Empfang einer Nachricht. Wird als Parameter
   *  null bergeben, weil keine Verschlsselung der Rckantwort gewnscht wird,
   *  muss trotzdem mit setCipherCertificate(X509Certificate) ein
   *  Verschlsselungszertifikat gesetzt werden, weil dies Voraussetzung fr
   *  die Teilnahme an OSCI ist.
   *
   *  @param  decrypter Decrypter-Objekt, welches den Inhalt der Nachricht entschlsseln
   *  soll
   */
  public Reader(Decrypter decrypter)
  {
    super(null, decrypter);
    idNr++;
    id += idNr;
  }

  /**
   *  Konstruktor fr das Versenden einer Nachricht.
   *
   *  @param  cipherCertificate Zertifikat, mit dem die Nachricht verschlsselt werden soll
   */
  public Reader(X509Certificate cipherCertificate)
  {
    super(null, cipherCertificate);
    idNr++;
    id += idNr;
  }

  //    public String getId() {return id + " " + idNr;}
  //    public String getId() {return String.valueOf(idNr);}
  public void setSignatureCertificate(X509Certificate signatureCertificate)
  {
    throw new UnsupportedOperationException();
  }
}
