package de.osci.osci12.signature;

import de.osci.osci12.OSCIException;


/**
 * Diese Exception zeigt ein Problem bei Signaturvorgngen
 * an. Die Bibliothek fat auch einige JCE/JCA-Exceptions hiermit zusammen, um (aus
 * Sicherheitsgrnden) keine detaillierten Informationen ber fehlgeschlagene
 * Signierversuche zu liefern.
 *
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class OSCISignatureException extends OSCIException
{
  /**
   * Creates a new OSCISignatureException object.
   *
   * @param errorCode undocumented
   */
  public OSCISignatureException(String errorCode)
  {
    super(errorCode);
  }

  /**
   * Creates a new OSCISignatureException object.
   *
   * @param errorCode undocumented
   */
  public OSCISignatureException(String errorCode, String addInfo)
  {
    super(addInfo, errorCode);
  }

  /**
   * Liefert die Exception-Nachricht in der jeweiligen Sprache (Default-Locale).
   * @return lokale Nachricht
   */
  public String getLocalizedMessage()
  {
    if (super.getMessage() == null)
      return super.getLocalizedMessage();
    else
      return super.getLocalizedMessage() + " '" + super.getMessage() + "'";
  }
}
