package de.osci.osci12.soapheader;

import de.osci.osci12.common.Constants;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.IOException;
import java.io.OutputStream;


/**
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class CustomHeader extends HeaderEntry
{
  private static Log log = LogFactory.getLog(OsciH.class);
  private String data;

  /**
   *  Constructor for the CustomHeader object
   *
   *@param  data  Description of Parameter
   */
  public CustomHeader(String data)
  {
    int i = data.indexOf(" Id=");

    if (i == -1)
      i = data.indexOf(" Id =");

    if ((i == -1) || (i > data.indexOf('>')))
      throw new IllegalArgumentException(de.osci.osci12.common.DialogHandler.text.getString("missing_entry") + ": Id");
    else
      i = data.indexOf('\"', i) + 1;

    setRefID(data.substring(i, data.indexOf('\"', i)));
    this.data = data;
    //    setRefID(name.toLowerCase());
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public String getData()
  {
    return data;
  }

  /**
   *  Description of the Method
   *
   *@param  out              Description of Parameter
   *@exception  IOException  Description of Exception
   */
  protected void writeXML(OutputStream out) throws IOException
  {
    if (log.isDebugEnabled())
      log.debug("Custom RefID: " + getRefID());

    out.write(data.getBytes(Constants.CHAR_ENCODING));
  }
}
