package de.osci.osci12.soapheader;

import de.osci.osci12.common.Constants;

import java.io.IOException;
import java.io.OutputStream;


/**
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class DesiredLanguagesH extends HeaderEntry
{
  //  private static Log log = LogFactory.getLog(DesiredLanguagesH.class);
  /** Liste der Sprachen im Format de,fr */
  private String languageList;

  /**
   * Creates a new DesiredLanguageH object.
   *
   * @param languageList undocumented
   */
  public DesiredLanguagesH(String languageList)
  {
    this.languageList = languageList;
  }

  /**
   * undocumented
   *
   * @return undocumented
   */
  public String getLanguageList()
  {
    return languageList;
  }

  /**
   * undocumented
   *
   * @param out undocumented
   *
   * @throws IOException undocumented
   */
  public void writeXML(OutputStream out) throws IOException
  {
    out.write(("<" + osciNSPrefix + ":DesiredLanguages").getBytes(Constants.CHAR_ENCODING));
    out.write(ns);
    out.write((" Id=\"desiredlanguages\" LanguagesList=\"" + languageList + "\" " + soapNSPrefix +
              ":actor=\"http://schemas.xmlsoap.org/soap/actor/next\" " + soapNSPrefix + ":mustUnderstand=\"1\"></" +
              osciNSPrefix + ":DesiredLanguages>").getBytes(Constants.CHAR_ENCODING));
  }
}
