package de.osci.osci12.soapheader;

import de.osci.osci12.common.Constants;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.io.IOException;
import java.io.OutputStream;


/**
 * <p>Copyright  2010 Freie Hansestadt Bremen</p>
 * <p>Erstellt von bremen online services Entwicklungs- und
 * Betriebsgesellschaft GmbH & Co. KG</p>
 * <p>Diese Bibliothek kann von jedermann nach Magabe der Bremer Lizenz fr
 * freie Softwarebibliotheken genutzt werden.</p>Die Lizenzbestimmungen knnen
 * unter der URL www.osci.de abgerufen oder bei der OSCI-Leitstelle,
 * Senator fr Finanzen, Freie Hansestadt Bremen, Postfach 10 15 40,
 * 28015 Bremen schriftlich angefordert werden.</p>
 *
 *
 * @author R. Lindemann, N.Bngener
 * @version 1.5
 */
public class OsciH extends HeaderEntry
{
  private static Log log = LogFactory.getLog(OsciH.class);
  String name;
  String data;

  /**
   *  Constructor for the OsciH object
   *
   *@param  name  Description of Parameter
   *@param  data  Description of Parameter
   */
  public OsciH(String name, String data)
  {
    this.name = name;
    this.data = data;
  }

  /**
   *  Gets the refID attribute of the OsciH object
   *
   *@return    The refID value
   */
  public String getRefID()
  {
    return name.toLowerCase();
  }

  /**
   *  Description of the Method
   *
   *@param  out              Description of Parameter
   *@exception  IOException  Description of Exception
   */
  public void writeXML(OutputStream out) throws IOException
  {
    if (log.isDebugEnabled())
      log.debug("RefID: " + getRefID());

    out.write(("<" + osciNSPrefix + ":" + name).getBytes(Constants.CHAR_ENCODING));
    out.write(ns);
    out.write((" Id=\"" + getRefID() + "\" " + soapNSPrefix + ":actor=\"http://schemas.xmlsoap.org/soap/actor/next\" " +
              soapNSPrefix + ":mustUnderstand=\"1\">").getBytes(Constants.CHAR_ENCODING));
    out.write(data.getBytes(Constants.CHAR_ENCODING));
    out.write(("</" + osciNSPrefix + ":" + name + ">").getBytes(Constants.CHAR_ENCODING));
  }
}
